{% extends "base_device.yaml.jinja2" %}

{% block device_setup %}
{%- set arch = "aarch64" %}
{%- set cpu = "cortex-a57" %}
{%- if settings.TARGET == "trs-qemuarm" %}
{%-   set arch = "arm" %}
{%-   set cpu = "cortex-a15" %}
{%- endif %}

{%- set os_url = "https://gitlab.com/Linaro/trustedsubstrate/ts-testing/-/jobs/artifacts/main/raw/image/efiboot.wic.xz?job=build" %}
{%- set os_filename = os_url.split('/')[-1].split('?')[0] %}
{%- set os, os_extension = splitext(os_filename) %}

device_type: qemu
job_name: {{ lava_job_name }}
timeouts:
  job:
    minutes: 60
  action:
    minutes: 60
  connection:
    minutes: 2
priority: 25
visibility: public
context:
  lava_test_results_dir: /var/lib/lava-%s
  arch: {{ arch }}
  machine: virt,secure=on
  cpu: {{ cpu }}
  guestfs_interface: virtio
  netdevice: user

actions:

- deploy:
    to: downloads
    failure_retry: 3
    timeout:
      minutes: 60
    images:
      {%- if testexport_url %}
      testexport:
        url: {{ testexport_url }}
      {%- endif %}
      os:
        url: {{ os_url }}
        compression: {{ os_extension[1:] }}
      firmware:
        {%- set firmware, _ = splitext(basename(firmware_url)) %}
        {%- set _, firmware_extension = splitext(firmware_url) %}
        url: {{ firmware_url }}
        compression: {{ firmware_extension[1:] }}
    postprocess:
      docker:
        image: debian
        steps:
          - apt-get update
          - apt-get install -qy mtools
          - mcopy -i efiboot.wic@@1048576 ::/EFI/BOOT/startup.nsh .
          - sed -i 's#ledge.efi -f.*#ledge.efi -f -u validation-linaro-org.s3.eu-west-1.amazonaws.com/testdata/ledge/yocto-arm64-lava.iso#g' startup.nsh
          - cat startup.nsh

- deploy:
    failure_retry: 3
    timeout:
      minutes: 60
    to: tmpfs
    images:
      os:
        image_arg: -drive id=disk1,file={os},if=none,format=raw -device virtio-blk-device,drive=disk1
          -nographic -device i6300esb,id=watchdog0 -m 2048 -smp 4
        url: downloads://{{ os }}
      firmware:
        image_arg: -drive if=pflash,unit=0,readonly=off,file={firmware},format=raw
        url: downloads://{{ firmware }}

- boot:
    method: qemu
    media: tmpfs
    docker:
      image: registry.gitlab.com/linaro/blueprints/qemu-swtpm
      binary: /usr/local/bin/qemu-system-aarch64-swtpm
    timeout:
      minutes: 40
    auto_login:
      login_prompt: 'login:'
      username: "root"
    prompts:
      - root@(.*):[/~]#
    transfer_overlay:
      download_command: wget -t 20
      unpack_command: tar -C /var/lib/ -xzvf

{% endblock %}
